std::deque(3)

NAME
std::deque -

SYNOPSIS

Inherits _Deque_base< _Tp, _Alloc >.

Detailed Description

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> class std::deque< _Tp, _Alloc >
Meets the requirements of a container, a reversible container, and a sequence, including the optional sequence requirements.

In previous HP/SGI versions of deque, there was an extra template parameter so users could control the node size. This extension turned out to violate the C++ standard (it can be detected using template template parameters), and it was removed.

Definition at line 612 of file stl_deque.h.

  Public Types
typedef _Alloc allocator_type
typedef _Base::const_iterator const_iterator
typedef _Tp_alloc_type::const_pointer const_pointer
typedef _Tp_alloc_type::const_reference const_reference
typedef std::reverse_iterator< const_iterator > const_reverse_iterator
typedef ptrdiff_t difference_type
typedef _Base::iterator iterator
typedef _Tp_alloc_type::pointer pointer
typedef _Tp_alloc_type::reference reference
typedef std::reverse_iterator< iterator > reverse_iterator
typedef size_t size_type
typedef _Tp value_type

  Public Member Functions
template<typename _InputIterator> void assign (_InputIterator __first, _InputIterator __last)
void assign (size_type __n, const value_type &__val)
const_reference at (size_type __n) const
reference at (size_type __n)
const_reference back () const
reference back ()
const_iterator begin () const
iterator begin ()
void clear ()
template<typename _InputIterator> deque (_InputIterator __first, _InputIterator __last, const allocator_type &__a=allocator_type())
deque (const deque &__x)
deque (size_type __n, const value_type &__value=value_type(), const allocator_type &__a=allocator_type())
deque (const allocator_type &__a=allocator_type())
bool empty () const
const_iterator end () const
iterator end ()
iterator erase (iterator __first, iterator __last)
iterator erase (iterator __position)
const_reference front () const
reference front ()
allocator_type get_allocator () const
template<typename _InputIterator> void insert (iterator __position, _InputIterator __first, _InputIterator __last)
void insert (iterator __position, size_type __n, const value_type &__x)
iterator insert (iterator position, const value_type &__x)
size_type max_size () const
deque & operator= (const deque &__x)
const_reference operator[] (size_type __n) const
reference operator[] (size_type __n)
void pop_back ()
void pop_front ()
void push_back (const value_type &__x)
void push_front (const value_type &__x)
const_reverse_iterator rbegin () const
reverse_iterator rbegin ()
const_reverse_iterator rend () const
reverse_iterator rend ()
void resize (size_type __new_size, value_type __x=value_type())
size_type size () const
void swap (deque &__x)
~deque ()

  Protected Types
enum { _S_initial_map_size }
typedef _Alloc::template rebind< _Tp * >::other _Map_alloc_type
typedef pointer * _Map_pointer
_S_initial_map_size

  Protected Member Functions
_Tp ** _M_allocate_map (size_t __n)
_Tp * _M_allocate_node ()
template<typename _ForwardIterator> void _M_assign_aux (_ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
template<typename _InputIterator> void _M_assign_aux (_InputIterator __first, _InputIterator __last, std::input_iterator_tag)
template<typename _InputIterator> void _M_assign_dispatch (_InputIterator __first, _InputIterator __last, __false_type)
template<typename _Integer> void _M_assign_dispatch (_Integer __n, _Integer __val, __true_type)
void _M_create_nodes (_Tp **__nstart, _Tp **__nfinish)
void _M_deallocate_map (_Tp **__p, size_t __n)
void _M_deallocate_node (_Tp *__p)
void _M_destroy_nodes (_Tp **__nstart, _Tp **__nfinish)
void _M_fill_assign (size_type __n, const value_type &__val)
void _M_fill_initialize (const value_type &__value)
void _M_fill_insert (iterator __pos, size_type __n, const value_type &__x)
_Map_alloc_type _M_get_map_allocator () const
const _Tp_alloc_type & _M_get_Tp_allocator () const
_Tp_alloc_type & _M_get_Tp_allocator ()
template<typename _InputIterator> void _M_initialize_dispatch (_InputIterator __first, _InputIterator __last, __false_type)
template<typename _Integer> void _M_initialize_dispatch (_Integer __n, _Integer __x, __true_type)
void _M_initialize_map (size_t)
template<typename _ForwardIterator> void _M_insert_aux (iterator __pos, _ForwardIterator __first, _ForwardIterator __last, size_type __n)
void _M_insert_aux (iterator __pos, size_type __n, const value_type &__x)
iterator _M_insert_aux (iterator __pos, const value_type &__x)
template<typename _InputIterator> void _M_insert_dispatch (iterator __pos, _InputIterator __first, _InputIterator __last, __false_type)
template<typename _Integer> void _M_insert_dispatch (iterator __pos, _Integer __n, _Integer __x, __true_type)
void _M_range_check (size_type __n) const
template<typename _ForwardIterator> void _M_range_insert_aux (iterator __pos, _ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
template<typename _InputIterator> void _M_range_insert_aux (iterator __pos, _InputIterator __first, _InputIterator __last, std::input_iterator_tag)

void _M_new_elements_at_back (size_type __new_elements)
void _M_new_elements_at_front (size_type __new_elements)
iterator _M_reserve_elements_at_back (size_type __n)
iterator _M_reserve_elements_at_front (size_type __n)

void _M_pop_back_aux ()
void _M_pop_front_aux ()
void _M_push_back_aux (const value_type &)
void _M_push_front_aux (const value_type &)

template<typename _ForwardIterator> void _M_range_initialize (_ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
template<typename _InputIterator> void _M_range_initialize (_InputIterator __first, _InputIterator __last, std::input_iterator_tag)

void _M_reallocate_map (size_type __nodes_to_add, bool __add_at_front)
void _M_reserve_map_at_back (size_type __nodes_to_add=1)
void _M_reserve_map_at_front (size_type __nodes_to_add=1)

  Static Protected Member Functions
static size_t _S_buffer_size ()

  Protected Attributes
_Deque_impl _M_impl

Constructor & Destructor Documentation

  deque (const allocator_type & __a = allocator_type()) [inline, explicit]

Default constructor creates no elements.

Definition at line 666 of file stl_deque.h.

  deque (size_type __n, const value_type & __value = value_type(), const allocator_type & __a = allocator_type()) [inline, explicit]

Create a deque with copies of an exemplar element.

Parameters:
    n The number of elements to initially create.
    value An element to copy.

This constructor fills the deque with n copies of value.

Definition at line 677 of file stl_deque.h.

References deque::_M_fill_initialize().

  deque (const deque< _Tp, _Alloc > & __x) [inline]

Deque copy constructor.

Parameters:
    x A deque of identical element and allocator types.

The newly-created deque uses a copy of the allocation object used by x.

Definition at line 689 of file stl_deque.h.

References std::__uninitialized_copy_a(), _Deque_base::_M_get_Tp_allocator(), _Deque_base::_M_impl, deque::begin(), and deque::end().

  deque (_InputIterator __first, _InputIterator __last, const allocator_type & __a = allocator_type()) [inline]

Builds a deque from a range.

Parameters:
    first An input iterator.
    last An input iterator.

Create a deque consisting of copies of the elements from [first, last).

If the iterators are forward, bidirectional, or random-access, then this will call the elements' copy constructor N times (where N is distance(first,last)) and do no memory reallocation. But if only input iterators are used, then this will do at most 2N calls to the copy constructor, and logN memory reallocations.

Definition at line 710 of file stl_deque.h.

References deque::_M_initialize_dispatch().

  ~deque () [inline]

The dtor only erases the elements, and note that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 724 of file stl_deque.h.

References std::_Destroy(), and _Deque_base::_M_get_Tp_allocator().

Member Function Documentation

  void assign (_InputIterator __first, _InputIterator __last) [inline]

Assigns a range to a deque.

Parameters:
    first An input iterator.
    last An input iterator.

This function fills a deque with copies of the elements in the range [first,last).

Note that the assignment completely changes the deque and that the resulting deque's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 766 of file stl_deque.h.

References deque::_M_assign_dispatch().

  void assign (size_type __n, const value_type & __val) [inline]

Assigns a given value to a deque.

Parameters:
    n Number of elements to be assigned.
    val Value to be assigned.

This function fills a deque with n copies of the given value. Note that the assignment completely changes the deque and that the resulting deque's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 749 of file stl_deque.h.

References deque::_M_fill_assign().

  const_reference at (size_type __n) const [inline]

Provides access to the data contained in the deque.

Parameters:
    n The index of the element for which data should be accessed.

Returns:
    Read-only (constant) reference to data.

Exceptions:
    std::out_of_range If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the deque. The function throws out_of_range if the check fails.

Definition at line 958 of file stl_deque.h.

References deque::_M_range_check().

  reference at (size_type __n) [inline]

Provides access to the data contained in the deque.

Parameters:
    n The index of the element for which data should be accessed.

Returns:
    Read/write reference to data.

Exceptions:
    std::out_of_range If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the deque. The function throws out_of_range if the check fails.

Definition at line 940 of file stl_deque.h.

References deque::_M_range_check().

  const_reference back () const [inline]

Returns a read-only (constant) reference to the data at the last element of the deque.

Definition at line 997 of file stl_deque.h.

References deque::end().

  reference back () [inline]

Returns a read/write reference to the data at the last element of the deque.

Definition at line 985 of file stl_deque.h.

References deque::end().

Referenced by deque::_M_insert_aux().

  const_iterator begin () const [inline]

Returns a read-only (constant) iterator that points to the first element in the deque. Iteration is done in ordinary element order.

Definition at line 791 of file stl_deque.h.

References _Deque_base::_M_impl.

  iterator begin () [inline]

Returns a read/write iterator that points to the first element in the deque. Iteration is done in ordinary element order.

Definition at line 783 of file stl_deque.h.

References _Deque_base::_M_impl.

Referenced by deque::_M_assign_aux(), deque::_M_fill_assign(), deque::deque(), deque::front(), deque::operator=(), and std::operator==().

  void clear ()

Erases all the elements. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 172 of file deque.tcc.

References std::_Destroy(), _Deque_base::_M_deallocate_node(), _Deque_base::_M_get_Tp_allocator(), _Deque_base::_M_impl, and deque::_S_buffer_size().

Referenced by deque::_M_range_initialize(), and deque::erase().

  bool empty () const [inline]

Returns true if the deque is empty. (Thus begin() would equal end().)

Definition at line 884 of file stl_deque.h.

References _Deque_base::_M_impl.

  const_iterator end () const [inline]

Returns a read-only (constant) iterator that points one past the last element in the deque. Iteration is done in ordinary element order.

Definition at line 809 of file stl_deque.h.

References _Deque_base::_M_impl.

  iterator end () [inline]

Returns a read/write iterator that points one past the last element in the deque. Iteration is done in ordinary element order.

Definition at line 800 of file stl_deque.h.

References _Deque_base::_M_impl.

Referenced by deque::_M_assign_aux(), deque::_M_fill_assign(), deque::back(), deque::deque(), deque::operator=(), and std::operator==().

  deque< _Tp, _Alloc >::iterator erase (iterator __first, iterator __last)

Remove a range of elements.

Parameters:
    first Iterator pointing to the first element to be erased.
    last Iterator pointing to one past the last element to be erased.

Returns:
    An iterator pointing to the element pointed to by last prior to erasing (or end()).

This function will erase the elements in the range [first,last) and shorten the deque accordingly.

The user is cautioned that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 132 of file deque.tcc.

References std::_Destroy(), _Deque_base::_M_destroy_nodes(), _Deque_base::_M_get_Tp_allocator(), _Deque_base::_M_impl, deque::clear(), std::copy(), std::copy_backward(), and deque::size().

  deque< _Tp, _Alloc >::iterator erase (iterator __position)

Remove element at given position.

Parameters:
    position Iterator pointing to element to be erased.

Returns:
    An iterator pointing to the next element (or end()).

This function will erase the element at the given position and thus shorten the deque by one.

The user is cautioned that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 111 of file deque.tcc.

References _Deque_base::_M_impl, std::copy(), std::copy_backward(), deque::pop_back(), deque::pop_front(), and deque::size().

Referenced by deque::_M_assign_aux(), deque::_M_fill_assign(), deque::operator=(), and deque::resize().

  const_reference front () const [inline]

Returns a read-only (constant) reference to the data at the first element of the deque.

Definition at line 977 of file stl_deque.h.

References deque::begin().

  reference front () [inline]

Returns a read/write reference to the data at the first element of the deque.

Definition at line 969 of file stl_deque.h.

References deque::begin().

Referenced by deque::_M_insert_aux().

  allocator_type get_allocator () const [inline]

Get a copy of the memory allocation object.

Reimplemented from _Deque_base.

Definition at line 774 of file stl_deque.h.

References _Deque_base::get_allocator().

  void insert (iterator __position, _InputIterator __first, _InputIterator __last) [inline]

Inserts a range into the deque.

Parameters:
    position An iterator into the deque.
    first An input iterator.
    last An input iterator.

This function will insert copies of the data in the range [first,last) into the deque before the location specified by pos. This is known as 'range insert.'

Definition at line 1127 of file stl_deque.h.

References deque::_M_insert_dispatch().

  void insert (iterator __position, size_type __n, const value_type & __x) [inline]

Inserts a number of copies of given data into the deque.

Parameters:
    position An iterator into the deque.
    n Number of elements to be inserted.
    x Data to be inserted.

This function will insert a specified number of copies of the given data before the location specified by position.

Definition at line 1112 of file stl_deque.h.

References deque::_M_fill_insert().

  deque< _Tp, _Alloc >::iterator insert (iterator position, const value_type & __x)

Inserts given value into deque before specified iterator.

Parameters:
    position An iterator into the deque.
    x Data to be inserted.

Returns:
    An iterator that points to the inserted data.

This function will insert a copy of the given value before the specified location.

Definition at line 90 of file deque.tcc.

References _Deque_base::_M_impl, deque::_M_insert_aux(), deque::push_back(), and deque::push_front().

Referenced by deque::_M_assign_aux(), deque::_M_fill_assign(), deque::operator=(), and deque::resize().

  size_type max_size () const [inline]

Returns the size() of the largest possible deque.

Definition at line 855 of file stl_deque.h.

  deque< _Tp, _Alloc > & operator= (const deque< _Tp, _Alloc > & __x)

Deque assignment operator.

Parameters:
    x A deque of identical element and allocator types.

All the elements of x are copied, but unlike the copy constructor, the allocator object is not copied.

Definition at line 69 of file deque.tcc.

References _Deque_base::_M_impl, deque::begin(), std::copy(), deque::end(), deque::erase(), deque::insert(), and deque::size().

  const_reference operator[] (size_type __n) const [inline]

Subscript access to the data contained in the deque.

Parameters:
    n The index of the element for which data should be accessed.

Returns:
    Read-only (constant) reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 915 of file stl_deque.h.

References _Deque_base::_M_impl.

  reference operator[] (size_type __n) [inline]

Subscript access to the data contained in the deque.

Parameters:
    n The index of the element for which data should be accessed.

Returns:
    Read/write reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 900 of file stl_deque.h.

References _Deque_base::_M_impl.

  void pop_back () [inline]

Removes last element.

This is a typical stack operation. It shrinks the deque by one.

Note that no data is returned, and if the last element's data is needed, it should be retrieved before pop_back() is called.

Definition at line 1078 of file stl_deque.h.

References _Deque_base::_M_impl, and deque::_M_pop_back_aux().

Referenced by deque::erase().

  void pop_front () [inline]

Removes first element.

This is a typical stack operation. It shrinks the deque by one.

Note that no data is returned, and if the first element's data is needed, it should be retrieved before pop_front() is called.

Definition at line 1057 of file stl_deque.h.

References _Deque_base::_M_impl, and deque::_M_pop_front_aux().

Referenced by deque::erase().

  void push_back (const value_type & __x) [inline]

Add data to the end of the deque.

Parameters:
    x Data to be added.

This is a typical stack operation. The function creates an element at the end of the deque and assigns the given data to it. Due to the nature of a deque this operation can be done in constant time.

Definition at line 1036 of file stl_deque.h.

References _Deque_base::_M_impl, and deque::_M_push_back_aux().

Referenced by deque::_M_insert_aux(), deque::_M_range_initialize(), and deque::insert().

  void push_front (const value_type & __x) [inline]

Add data to the front of the deque.

Parameters:
    x Data to be added.

This is a typical stack operation. The function creates an element at the front of the deque and assigns the given data to it. Due to the nature of a deque this operation can be done in constant time.

Definition at line 1015 of file stl_deque.h.

References _Deque_base::_M_impl, and deque::_M_push_front_aux().

Referenced by deque::_M_insert_aux(), and deque::insert().

  const_reverse_iterator rbegin () const [inline]

Returns a read-only (constant) reverse iterator that points to the last element in the deque. Iteration is done in reverse element order.

Definition at line 827 of file stl_deque.h.

  reverse_iterator rbegin () [inline]

Returns a read/write reverse iterator that points to the last element in the deque. Iteration is done in reverse element order.

Definition at line 818 of file stl_deque.h.

  const_reverse_iterator rend () const [inline]

Returns a read-only (constant) reverse iterator that points to one before the first element in the deque. Iteration is done in reverse element order.

Definition at line 844 of file stl_deque.h.

  reverse_iterator rend () [inline]

Returns a read/write reverse iterator that points to one before the first element in the deque. Iteration is done in reverse element order.

Definition at line 836 of file stl_deque.h.

  void resize (size_type __new_size, value_type __x = value_type()) [inline]

Resizes the deque to the specified number of elements.

Parameters:
    new_size Number of elements the deque should contain.
    x Data with which new elements should be populated.

This function will resize the deque to the specified number of elements. If the number is smaller than the deque's current size the deque is truncated, otherwise the deque is extended and new elements are populated with given data.

Definition at line 870 of file stl_deque.h.

References deque::erase(), deque::insert(), and deque::size().

  size_type size () const [inline]

Returns the number of elements in the deque.

Definition at line 850 of file stl_deque.h.

References _Deque_base::_M_impl.

Referenced by deque::_M_assign_aux(), deque::_M_fill_assign(), deque::_M_insert_aux(), deque::erase(), deque::operator=(), std::operator==(), and deque::resize().

  void swap (deque< _Tp, _Alloc > & __x) [inline]

Swaps data with another deque.

Parameters:
    x A deque of the same element and allocator types.

This exchanges the elements between two deques in constant time. (Four pointers, so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(d1,d2) will feed to this function.

Definition at line 1180 of file stl_deque.h.

References _Deque_base::_M_impl, and std::swap().

Referenced by std::swap().

Author

Generated automatically by Doxygen for libstdc++ from the source code.